/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jepcustom;

import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;
import java.text.DecimalFormat;

/**
 *
 * @author Carlos Mario
 */
public class ContextoPrecision {

    public static int getScale() {
        return scale;
    }

    public static void setScale(int aScale) {
        scale = aScale;
    }

    /*private static MathContext precision = new MathContext(6, RoundingMode.HALF_EVEN);
    
    public static void setMargenPrecision(int cifras){
    precision = new MathContext(cifras + 2, RoundingMode.HALF_EVEN);
    }
    
    public static MathContext getMargenPrecision(){
    return precision;
    }*/
    private static int scale = 2;

    public static double redondear2(double val) {
        if (Double.isNaN(val) || Double.isInfinite(val)) {
            return val;
        }
        String newVal = new BigDecimal(val).toString();
        String[] div = newVal.split("\\.");
        if (div.length == 0) {
            return val;
        }

        int cifrasEnteras = div[0].length();

        if (div[0].equals("0")) {
            cifrasEnteras = 0;
        }

        MathContext precision = new MathContext(cifrasEnteras + getScale(), RoundingMode.HALF_EVEN);

        return new BigDecimal(val, precision).doubleValue();
    }

    public static double redondear(double val) {
        double factor = Math.pow(10, getScale());

        if (Double.isInfinite(val) || Double.isNaN(val)) {
            return val;
        }

        /*System.out.println("VALOR : "+val);
        System.out.println("FACTOR : "+factor);
        System.out.println("RESULTADO : "+(val*factor));
        System.out.println("REDONDEO : "+Math.round(val*factor));*/
        //(Math.round(val * factor) / factor);
        long entero = (long) val;
        val = val - entero;
        return entero + (Math.round(val * factor) / factor);
    }

    public static void main(String[] args) {
        ContextoPrecision.setScale(10);
        System.out.println("r: " + redondear(-8.023925038183));


    }
}
